;												
; THERMOMETER analog ATmega8 KTY81-122			
; Bernhard.Erfurt@gmx.de						
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> 										
; PB1 ==> 										
; PB2 ==> 										
; PB3 ==> OUT PWM								
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> 										
; PB7 ==> 										
;												
; PC0 ==> KTY81-122 (ADC0)						
; PC1 ==> REF									
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> TASTE "+"								
; PD1 ==> TASTE "-"								
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT							=1000000	; 1 MHz	
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD
; REFERENZ										
.equ REF_PIN_NR						= 1
.equ REF_DDR						= DDRC
.equ REF_PORT						= PORTC
; TASTE "PLUS"									
.equ TASTE_PLUS_PIN_NR				= 0
.equ TASTE_PLUS_PIN					= PIND
.equ TASTE_PLUS_DDR					= DDRD
.equ TASTE_PLUS_PORT				= PORTD
; TASTE "MINUS"									
.equ TASTE_MINUS_PIN_NR				= 1
.equ TASTE_MINUS_PIN				= PIND
.equ TASTE_MINUS_DDR				= DDRD
.equ TASTE_MINUS_PORT				= PORTD
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=SRAM_START		; 0x0060 START Adresse 		

.equ adr_TASTE						=SRAM_START+10

.equ adr_KTY_OFFSET_L				=SRAM_START+30
.equ adr_KTY_OFFSET_H				=SRAM_START+31

.equ adr_ADC_0_L					=SRAM_START+50
.equ adr_ADC_0_H					=SRAM_START+51
.equ adr_ADC_1_L					=SRAM_START+52
.equ adr_ADC_1_H					=SRAM_START+53
.equ adr_ADC_2_L					=SRAM_START+54
.equ adr_ADC_2_H					=SRAM_START+55
.equ adr_ADC_3_L					=SRAM_START+56
.equ adr_ADC_3_H					=SRAM_START+57
.equ adr_ADC_4_L					=SRAM_START+58
.equ adr_ADC_4_H					=SRAM_START+59
.equ adr_ADC_5_L					=SRAM_START+60
.equ adr_ADC_5_H					=SRAM_START+61

.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; REGISTER										

.def NULL 	= R12
.def EINS 	= R14

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
	rcall SRAM_CLEAR
; PORT_CLEAR										
	rcall PORT_CLEAR
; REGISTER-CLEAR									
	rcall REGISTER_CLEAR
; LED_INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED-TEST											
	rcall LED_TEST
; ADC_INITIALISIERUNG								
	rcall ADC_INITIALISIERUNG
; TIMER2_PWM_INITIALISIEREN							
	rcall TIMER2_PWM_INITIALISIERUNG
; KTY_INITIALISIERUNG								
	rcall KTY_INITIALISIERUNG
; TASTATUR_INITIALISIERUNG							
	rcall TASTATUR_INITIALISIERUNG
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
; EEPROM_KONFIGURATION_LADEN						
	rcall EEPROM_KONFIGURATION_LADEN
; PROGRAMM_CHECK									
	rcall PROGRAMM_CHECK
; Interrupts freigeben								
	sei
; ##############################################################################
; ##############################################################################
; ##############################################################################
	; LED GRN			
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
	rcall TASTATUR_ABFRAGE
	rcall TASTATUR_AUSWERTUNG

	rcall KTY_MESSUNG

	rcall PROGRAMM_CHECK
	rcall wait_1s
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "THERMO_TIMER_PWM.asm"			; TIMER-PWM						
.include "THERMO_ADC.asm"				; ADC							
.include "THERMO_KTY.asm"				; KTY81-122						
.include "THERMO_SONSTIGES.asm"			; sonstiges						
.include "THERMO_TASTEN.asm"			; Tasten						
.include "THERMO_EEPROM.asm"			; EEPROM						
.include "THERMO_WAIT_01MHZ.asm"		; 1 MHz							


; Wandelt ADC-WERT in PWM-WERT um												
TABELLE_KTY:
.db   0,  3,  5,  7,  9, 10, 13, 15, 18, 20
.db  23, 25, 28, 30, 33, 35, 37, 39, 40, 43
.db  45, 48, 50, 53, 55, 58, 60, 63, 65, 67
.db  69, 70, 73, 75, 78, 80, 83, 85, 88, 90
.db  93, 95, 98,100,103,105,108,110,112,114
.db 115,118,120,123,125,128,130,133,135,138
.db 140,143,145,148,150,153,155,158,160,163
.db 165,168,170,173,175,178,180,183,185,188
.db 190,193,195,198,200,203,205,208,210,213
.db 215,218,220,223,225,228,230,233,235,238
.db 240,243,245,248,250,255

